// cview_basicView.h : interface of the CCview_basicView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CVIEW_BASICVIEW_H__86C5DC69_9D63_4FC0_9380_5B72D91CCDCC__INCLUDED_)
#define AFX_CVIEW_BASICVIEW_H__86C5DC69_9D63_4FC0_9380_5B72D91CCDCC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "gl\gl.h"
#include "gl\glu.h"


class CCview_basicView : public CView
{
protected: // create from serialization only
	CCview_basicView();
	DECLARE_DYNCREATE(CCview_basicView)

// Attributes
public:
	CCview_basicDoc* GetDocument();

	CPalette    m_cPalette;
	CPalette    *m_pOldPalette;
	CRect       m_oldRect;
	float       m_fRadius;
	CClientDC   *m_pDC;

	float x,y,z,r,xbounce,ybounce,zbounce,r_radius;

	BOOL rotatex, rotatey, rotatez;

	GLfloat m_xRot, m_yRot, m_zRot;

	HGLRC m_hRC;	//Rendering Context

	GLuint m_Texture[3];
	GLdouble m_texWrap, m_texFilter, m_texMode;
	
	HBITMAP hBmp;
	BITMAP BM;

// Operations
public:

	BOOL InitializeOpenGL();

	BOOL SetupPixelFormat(void);

	void DrawScene(void);
	void LoadTexture (int bitmapName, int texName);
	void LoadGLTextures();
	void SetupLighting();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCview_basicView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCview_basicView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:



// Generated message map functions
protected:
	//{{AFX_MSG(CCview_basicView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in cview_basicView.cpp
inline CCview_basicDoc* CCview_basicView::GetDocument()
   { return (CCview_basicDoc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CVIEW_BASICVIEW_H__86C5DC69_9D63_4FC0_9380_5B72D91CCDCC__INCLUDED_)
